package com.utopiaindustries.qualitychecker.ui.fragments;

import android.annotation.SuppressLint;
import android.content.Context;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.Spinner;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AlertDialog;
import androidx.fragment.app.Fragment;
import androidx.navigation.NavController;
import androidx.navigation.Navigation;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.bumptech.glide.Glide;
import com.utopiaindustries.qualitychecker.R;
import com.utopiaindustries.qualitychecker.apiservice.ApiService;
import com.utopiaindustries.qualitychecker.apiservice.ApiServiceFactory;
import com.utopiaindustries.qualitychecker.db.DimensionRepository;
import com.utopiaindustries.qualitychecker.db.InspectionCheckpointSkuRepository;
import com.utopiaindustries.qualitychecker.db.ProductRepository;
import com.utopiaindustries.qualitychecker.models.InspectionCheckpointSku;
import com.utopiaindustries.qualitychecker.models.InspectionDimension;
import com.utopiaindustries.qualitychecker.models.InspectionReportItem;
import com.utopiaindustries.qualitychecker.models.Product;
import com.utopiaindustries.qualitychecker.service.InspectionReportService;
import com.utopiaindustries.qualitychecker.store.Store;
import com.utopiaindustries.qualitychecker.ui.adapter.ItemHistoryAdapter;
import com.google.zxing.integration.android.IntentIntegrator;
import com.journeyapps.barcodescanner.CaptureActivity;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;

import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

public class FirstStepFragment extends Fragment implements View.OnClickListener {

    private  NavController navController;
    private Button leftFab,rightFab,showHistoryBtn;
    private EditText sku,boxCarton,itemPerBox,pieces,packagingDetails,boxCartonSelected,itemPerBoxSelected,piecesSelected;
    private Spinner markerplace,modelNumber,title,color,size;
    private CheckBox fri,refri;
    private ImageButton searchSku,scanBtn;
    private TextView profileName;
    private ImageView profileImage;
    private ApiService apiService;
    private Store store;

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragment_first_step , container, false );
        initializeViews( view );
        apiService = ApiServiceFactory.getApiService();
        store = Store.getInstance();
        // set on click listener
        leftFab.setOnClickListener( this );
        rightFab.setOnClickListener( this );
        searchSku.setOnClickListener( this );
        scanBtn.setOnClickListener( this );
        showHistoryBtn.setOnClickListener( this );
        populateItem( store.getProducts(), true );
        prePopulateData( store.getProducts() );
        updateProfileViews();

        fri.setOnCheckedChangeListener((buttonView, isChecked) -> {
            if( isChecked ){
                store.getReport().setFri( true );
                refri.setChecked( false );
            } else {
                store.getReport().setFri( false );
                refri.setChecked( true );
            }
        });

        refri.setOnCheckedChangeListener((buttonView, isChecked) -> {
            if( isChecked ){
                store.getReport().setFri( false );
                fri.setChecked( false );
            } else {
                store.getReport().setFri( true );
                fri.setChecked( true );
            }
        });

        // marketplace
        markerplace.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {


            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                if( parent.getItemAtPosition( position ) != null ){
                    String marketplaceOption = parent.getItemAtPosition( position ).toString();
                    store.getReport().getItems().get(0).setMarketplace( marketplaceOption  );
                    System.out.println( marketplaceOption );
                    populateProductDataOnSelection(
                            store.getReport().getItems().get(0).getSku(),
                            marketplaceOption,
                            false
                    );
                }
            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {
                store.getReport().getItems().get(0).setMarketplace("");
            }
        });

        // title
        title.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                if( parent.getItemAtPosition( position ) != null ){
                    String titleOption = parent.getItemAtPosition( position ).toString();
                    store.getReport().getItems().get(0).setTitle( titleOption  );
                }
            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {
                store.getReport().getItems().get(0).setTitle("");
            }
        });

        // model
        modelNumber.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                if( parent.getItemAtPosition( position ) != null ){
                    String modelOption = parent.getItemAtPosition( position ).toString();
                    store.getReport().getItems().get(0).setModelNumber( modelOption  );
                }
            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {
                store.getReport().getItems().get(0).setModelNumber("");
            }
        });

        // color
        color.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                if( parent.getItemAtPosition( position ) != null ){
                    String colorOption = parent.getItemAtPosition( position ).toString();
                    store.getReport().getItems().get(0).setSmColor( colorOption  );
                }
            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {
                store.getReport().getItems().get(0).setSmColor("");
            }
        });

        // size
        size.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                if( parent.getItemAtPosition( position ) != null ){
                    String sizeOption = parent.getItemAtPosition( position ).toString();
                    store.getReport().getItems().get(0).setSmSize( sizeOption  );
                }
            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {
                store.getReport().getItems().get(0).setSmSize("");
            }
        });

        boxCartonSelected.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                try {
                    store.getReport().getItems().get(0).setCartonsSelected( Long.parseLong( s.toString() ) );
                } catch ( Exception e ){
                    store.getReport().getItems().get(0).setCartonsSelected( 0 );
                }
            }

            @Override
            public void afterTextChanged(Editable s) {

            }
        });

        itemPerBoxSelected.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                try {
                    store.getReport().getItems().get(0).setPacksSelected( Long.parseLong( s.toString() ) );
                } catch ( Exception e ){
                    store.getReport().getItems().get(0).setPacksSelected( 0 );
                }
            }

            @Override
            public void afterTextChanged(Editable s) {

            }
        });

        piecesSelected.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                try {
                    store.getReport().getItems().get(0).setPiecesSelected( Long.parseLong( s.toString() ) );
                } catch ( Exception e ){
                    store.getReport().getItems().get(0).setPiecesSelected( 0 );
                }
            }

            @Override
            public void afterTextChanged(Editable s) {

            }
        });

//        generalRemarks.addTextChangedListener(new TextWatcher() {
//            @Override
//            public void beforeTextChanged(CharSequence s, int start, int count, int after) {
//
//            }
//
//            @Override
//            public void onTextChanged(CharSequence s, int start, int before, int count) {
//                try {
//                    store.getReport().setGeneralRemarks( s.toString()  );
//                } catch ( Exception e ){
//                    store.getReport().setGeneralRemarks( "");
//                }
//            }
//
//            @Override
//            public void afterTextChanged(Editable s) {
//
//            }
//        });

        return view;
    }

    @Override
    public void onClick(View v) {
        navController = Navigation.findNavController( requireView() );
        if( v.getId() == R.id.button_left_frag_1 ){
            if( getActivity() != null ){
                getActivity().finish();
            }
        }
        if( v.getId() == R.id.button_right_frag_1 ){
            navController.navigate( R.id.action_firstStepFragment_to_secondStepFragment );
        }
        if( v.getId() == R.id.search_sku_btn  ){
            if( sku.getText() != null ){
                populateProductDataOnSelection( sku.getText().toString(), "", true );
                populateSkuCheckpointsParams( sku.getText().toString() );
            }
        }
        if( v.getId() == R.id.scan_sku_btn ){
            IntentIntegrator integrator = new IntentIntegrator( getActivity() );
            integrator.setCaptureActivity(CaptureActivity.class);
            integrator.setOrientationLocked( true );
            integrator.setBarcodeImageEnabled( true );
            integrator.initiateScan();
        }
        if( v.getId() == R.id.button_show_history ){
           openItemHistoryDialog();
        }
    }

    private void populateSkuCheckpointsParams( String sku ){
        if( sku != null && ! sku.isEmpty() ){
           List<InspectionCheckpointSku> checkpointSkus =  new InspectionCheckpointSkuRepository( getContext() )
                    .findBySku( sku );
            System.out.println( checkpointSkus );
            store.setCheckpointSkus( checkpointSkus );
        }
    }

    private void populateProductDataOnSelection( String sku, String marketplace , boolean populateMarketplace){
        // setting the product details
        if( sku != null ){
            String skuStr = sku.trim();
            List<Product> products = new ProductRepository( getContext() ).getProductBySkuOrAsin( skuStr, marketplace );
            System.out.println( products );
            Product product = products.stream().findFirst().orElse( new Product() );
            store.getReport().getItems().get(0).setSku( product.getSku() );
            store.getReport().getItems().get(0).setAsin( product.getAsin() );
            populateItem( products, populateMarketplace );
            store.setProducts( products );
            if(  product.getCategory() !=  null ){
                List<InspectionDimension> dimensions = new DimensionRepository( getContext() ).findByCategory(
                        product.getCategory()
                );
                store.setDimensionList( dimensions );
            }
        }
    }
    private void prePopulateData( List<Product> products ){
        fri.setChecked( store.getReport().getFri() );
        refri.setChecked( ! store.getReport().getFri() );
        // sku
        sku.setText( store.getReport().getItems().get(0).getSku() );
        System.out.println( products );
        System.out.println( store.getReport().getItems().get(0) );

        if( ! products.isEmpty() ){
            List<String> modelNumbers =  products.stream().map( Product::getModelNumber ).distinct().collect(Collectors.toList()) ;

            String defaultModelSelection = store.getReport().getItems().get(0).getModelNumber();
            int defaultModelSelectionIndex = modelNumbers.indexOf( defaultModelSelection );
            modelNumber.setSelection( defaultModelSelectionIndex  );
        }

        if( ! products.isEmpty() ){
            List<String> titles =  products.stream().map( Product::getTitle ).distinct().collect(Collectors.toList()) ;
            String defaultTitleSelection = store.getReport().getItems().get(0).getTitle();
            int defaultTitleSelectionIndex = titles.indexOf( defaultTitleSelection );
            title.setSelection( defaultTitleSelectionIndex  );
        }

    }

    private void populateItem( List<Product> products , boolean populateMarketplace){
        if( populateMarketplace ){
            populateMarketplaces( products );
        }
        populateMmodelNumber(products );
        populateTitle( products );
        populateColor( products );
        populateSize( products );
        populateItemPresentedDetails( products );
    }

    private void populateItemPresentedDetails( List<Product> products ){
        try{
            if( ! products.isEmpty() ){
                Product product = products.get( 0 );
                String inventory = String.valueOf( product.getInventory() );
                String itemPerBoxText =  String.valueOf( product.getInventory() * product.getItemPerPack() );
                String boxCartonText = String.valueOf(  ( product.getInventory() / product.getItemPerBox() )  );

                @SuppressLint("DefaultLocale") String packagingDetailsText = String.format("%d Item per Pack, %d Pack per Box", product.getItemPerPack(), product.getItemPerBox() );
                itemPerBox.setText( inventory );
                pieces.setText(  itemPerBoxText );
                boxCarton.setText( boxCartonText );
                packagingDetails.setText( packagingDetailsText );

                boxCartonSelected.setText( String.valueOf( store.getReport().getItems().get(0).getCartonsSelected() ));
                itemPerBoxSelected.setText( String.valueOf( store.getReport().getItems().get(0).getPacksSelected() ) );
                piecesSelected.setText( String.valueOf( store.getReport().getItems().get(0).getPiecesSelected() ) );
             //   generalRemarks.setText( store.getReport().getItems().get(0).getSampleSize() );

                store.getReport().getItems().get(0).setTotalPresentPieces( Long.parseLong( inventory ) );
                store.getReport().getItems().get(0).setTotalPresentPacks( Long.parseLong( itemPerBoxText ) );
                store.getReport().getItems().get(0).setTotalPresentCartons( Long.parseLong( boxCartonText ) );
                store.getReport().getItems().get(0).setPackingDetails( packagingDetailsText );

            }
        } catch ( Exception e){
            itemPerBox.setText( "0" );
            pieces.setText( "0" );
            boxCarton.setText( "0" );
            packagingDetails.setText( "" );
        }
    }


    private void populateSize( List<Product>  products ){
        List<String> sizes =  Collections.singletonList("[Size]");
        if( ! products.isEmpty() ){
            sizes = products.stream().map( Product::getSmSize ).distinct().filter(Objects::nonNull).collect(Collectors.toList() );
        }
        if( !sizes.isEmpty() ){
            ArrayAdapter<String> adapter = new ArrayAdapter<>( Objects.requireNonNull(getContext() ),
                    android.R.layout.simple_spinner_dropdown_item, sizes.toArray( new String[0]) );
            size.setAdapter( adapter );
            //
            String sizeOption = (String) size.getSelectedItem();
            store.getReport().getItems().get(0).setSmSize( sizeOption );
        }
    }

    private void populateColor( List<Product>  products ){
        List<String> colors =  Collections.singletonList("[Color]");
        if( ! products.isEmpty() ){
            colors = products.stream().map( Product::getSmColor ).distinct().filter(Objects::nonNull).collect(Collectors.toList() );
        }
        if( !colors.isEmpty() ){

            ArrayAdapter<String> adapter = new ArrayAdapter<>( Objects.requireNonNull(getContext() ),
                    android.R.layout.simple_spinner_dropdown_item, colors.toArray( new String[0]) );
            color.setAdapter( adapter );
            String colorOption = (String) color.getSelectedItem();
            store.getReport().getItems().get(0).setSmColor( colorOption );
        }
    }

    private void populateTitle( List<Product>  products ){
       List<String> titles =  Collections.singletonList("[Title]");
        if( ! products.isEmpty() ){
            titles = products.stream().map( Product::getTitle ).distinct().filter(Objects::nonNull).collect(Collectors.toList()) ;
        }
        if( !titles.isEmpty() ){
            ArrayAdapter<String> adapter = new ArrayAdapter<>( getContext(), android.R.layout.simple_spinner_dropdown_item, titles.toArray( new String[0] ));
            title.setAdapter( adapter );
            String titleOption = (String) title.getSelectedItem();
            store.getReport().getItems().get(0).setTitle( titleOption );
        }
    }


    private void populateMmodelNumber( List<Product>  products ){
        List<String> modelNumbers = Collections.singletonList("[Model Number]");
        if( ! products.isEmpty() ){
            modelNumbers = products.stream().map( Product::getModelNumber ).distinct().filter(Objects::nonNull).collect(Collectors.toList() ) ;
        }
        if( !modelNumbers.isEmpty() ){
            ArrayAdapter<String> adapter = new ArrayAdapter<>( getContext(), android.R.layout.simple_spinner_dropdown_item, modelNumbers.toArray(new String[0] ));
            modelNumber.setAdapter( adapter );

            String modelOption = (String) modelNumber.getSelectedItem();
            store.getReport().getItems().get(0).setMarketplace( modelOption );
        }
    }

    private void populateMarketplaces( List<Product>  products ){
        List<String> marketplaces = Collections.singletonList("[ Marketplace ]");
        if( ! products.isEmpty() ){
            marketplaces = products.stream().map( Product::getMarketplace ).distinct().filter(Objects::nonNull).collect(Collectors.toList() );
        }
        if( ! marketplaces.isEmpty()){
            ArrayAdapter<String> adapter = new ArrayAdapter<>( getContext(), android.R.layout.simple_spinner_dropdown_item, marketplaces.toArray(new String[0] ));
            markerplace.setAdapter( adapter );
            //
            String marketplaceOption = (String) markerplace.getSelectedItem();
            store.getReport().getItems().get(0).setMarketplace( marketplaceOption );
        }
    }


    /*
    *  initialize views
    * */
    private void initializeViews( View view ){
        leftFab = view.findViewById( R.id.button_left_frag_1 );
        rightFab = view.findViewById( R.id.button_right_frag_1 );
        markerplace = view.findViewById( R.id.marketplace );
        sku = view.findViewById( R.id.sku );
        modelNumber = view.findViewById( R.id.model_number );
        title = view.findViewById( R.id.title );
        color = view.findViewById( R.id.color );
        size = view.findViewById( R.id.size );
        boxCarton = view.findViewById( R.id. box_carton );
        itemPerBox = view.findViewById( R.id.item_per_box );
        pieces  = view.findViewById( R.id.pieces );
        packagingDetails = view.findViewById( R.id.packaging );
        boxCartonSelected = view.findViewById( R.id.box_carton_selected );
        itemPerBoxSelected = view.findViewById( R.id.item_per_box_selected );
        piecesSelected = view.findViewById( R.id.pieces_selected );
        fri = view.findViewById( R.id.fri );
        refri = view.findViewById( R.id.refri );
        searchSku = view.findViewById( R.id.search_sku_btn );
        profileName= view.findViewById( R.id.first_step_name );
        profileImage = view.findViewById( R.id.first_step_profile_image );
        scanBtn = view.findViewById( R.id.scan_sku_btn );
        showHistoryBtn = view.findViewById( R.id.button_show_history );
    }

    public void onBarcodeScanResult( String result ){
        if( result != null && ! result.isEmpty() ){
            store.getReport().getItems().get(0).setSku( result );
            sku.setText( result );
        }
    }

    private void openItemHistoryDialog() {
        LayoutInflater inflater = LayoutInflater.from( getContext() );
        View dialogView = inflater.inflate( R.layout.item_history, null);
        // recycler view
        RecyclerView itemHistoryRecyclerView = dialogView.findViewById( R.id.item_history_recyclerview );
        LinearLayoutManager layoutManager = new LinearLayoutManager( getContext() );
        itemHistoryRecyclerView.setLayoutManager( layoutManager );
        AlertDialog.Builder builder = new AlertDialog.Builder( Objects.requireNonNull(getContext()) );

        // set adapter
        ItemHistoryAdapter itemHistoryAdapter = new ItemHistoryAdapter( new ArrayList<>());
        itemHistoryRecyclerView.setAdapter( itemHistoryAdapter );

        builder.setView(dialogView)
                .setTitle("Item History")
                .setPositiveButton( "OK",(dialog, which) -> {
                    dialog.dismiss();
                } )
                .setNegativeButton("Cancel", (dialog, which) -> {
                    // Handle Cancel button click
                    dialog.dismiss();
                });
        if( store.getReport().getItems().get(0).getSku() != null ){
            apiService.fetchItemsLogs( store.getReport().getItems().get(0).getSku() ).enqueue(
                    new Callback<List<InspectionReportItem>>() {
                        @SuppressLint("NotifyDataSetChanged")
                        @Override
                        public void onResponse(Call<List<InspectionReportItem>> call, Response<List<InspectionReportItem>> response) {
                            if( response.isSuccessful() && response.body() != null ){
                                // set adapter
                                System.out.println( response.body() );
                                ItemHistoryAdapter itemHistoryAdapter = new ItemHistoryAdapter( response.body() );
                                itemHistoryRecyclerView.setAdapter( itemHistoryAdapter );
                                itemHistoryAdapter.notifyDataSetChanged();
                            }
                        }

                        @Override
                        public void onFailure(Call<List<InspectionReportItem>> call, Throwable t) {
                            System.out.println( t.getMessage() );
                        }
                    }
            );
        }
        // Show the dialog
        AlertDialog dialog = builder.create();
        dialog.show();
    }

    private void updateProfileViews( ) throws NullPointerException{
        SharedPreferences sharedPreferences = getActivity().getSharedPreferences("login_prefs", Context.MODE_PRIVATE);
        profileName.setText( sharedPreferences.getString("name", null ) );
        Glide.with( getContext() )
                .load( store.getProfileImage( ) )
                .into( profileImage );
    }
}
